#pragma once

using namespace Platform;
using namespace Windows::UI::Xaml::Data;

namespace SenseHat {

	namespace Sensors {

		namespace ViewModels {

			[Bindable]
			public ref class SensorsViewModel sealed : INotifyPropertyChanged
			{
			public:
				SensorsViewModel();

				virtual event PropertyChangedEventHandler^ PropertyChanged;

				property double Temperature
				{
					double get() { return temperature; }
					void set(double value)
					{
						temperature = value;
						OnPropertyChanged("Temperature");
					}
				}

				property bool IsTelemetryActive
				{
					bool get() { return isTelemetryActive; }
					void set(bool value)
					{
						isTelemetryActive = value;
						OnPropertyChanged("IsTelemetryActive");

						ToggleStartStopButtons(!value);
					}
				}

				property bool IsStartSensorReadingButtonEnabled
				{
					bool get() { return isStartSensorReadingButtonEnabled; }
					private: void set(bool value) { isStartSensorReadingButtonEnabled = value; }
				}

				property bool IsStopSensorReadingButtonEnabled
				{
					bool get() { return isStopSensorReadingButtonEnabled; }
					private: void set(bool value) { isStopSensorReadingButtonEnabled = value; }
				}
				
			private:				
				bool isTelemetryActive;
				bool isStartSensorReadingButtonEnabled;
				bool isStopSensorReadingButtonEnabled;

				double temperature;

				void ToggleStartStopButtons(bool isStartEnabled);
				void OnPropertyChanged(String^ propertyName)
				{					
					PropertyChanged(this, ref new PropertyChangedEventArgs(propertyName));
				}				
			};
		}
	}
}

