#pragma once

#include <ppltasks.h>
#include "TelemetryEventArgs.h"

using namespace Concurrency;
using namespace Platform;

namespace SenseHat {

	namespace Sensors {

		namespace TelemetryControl {

			public delegate void DataReadyEventHandler(Object^ sender, TelemetryEventArgs^ e);

			ref class Telemetry sealed
			{
			public:
				event DataReadyEventHandler^ DataReady;

				void OnDataReady(Object^ sender, TelemetryEventArgs^ e)
				{
					DataReady(this, e);
				}

				property bool IsActive
				{
					public: bool get() { return isActive; }
					private: void set(bool value) { isActive = value; }
				}

				void Start();
				void Stop();

			private:
				const int msDelayTime = 1000;
				bool isActive;

				task<void> telemetryTask;
				cancellation_token_source *telemetryCancellationTokenSource;

				void InitializeTelemetryTask();
				TelemetryEventArgs^ GetSensorReading();
			};
		}
	}
}

