﻿using System;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Threading.Tasks;

namespace AnomalyDetection.PredictiveClient
{
    public class PredictiveServiceClient
    {
        private const string postAddress = "https://ussouthcentral.services.azureml.net/workspaces/98a5ed908d9a4055afb9b3b79cc604b2/services/9e6fa6e53d3041f7810d505409ad6253/execute?api-version=2.0&details=true";
        private const string apiKey = "n7BtX1c7Gg+puhidQt6uEjjrsPa4T+E09yfuBF73aa8bQunr4plz7gZ+au9wxSyPyKcgv8gFsCn6fZDlcuB9wQ==";

        private HttpClient httpClient;

        public PredictiveServiceClient()
        {
            httpClient = new HttpClient()
            {
                BaseAddress = new Uri(postAddress),
            };

            httpClient.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Bearer", apiKey);
        }

        public async Task<PredictionScore> PredictAnomalyAsync(double temperature)
        {
            var predictionRequest = new PredictionRequest(temperature);

            var response = await httpClient.PostAsJsonAsync(string.Empty, predictionRequest);

            PredictionScore predictionScore;

            if (response.IsSuccessStatusCode)
            {
                var scoreResponse = await response.Content.ReadAsAsync<PredictionResponse>();

                predictionScore = new PredictionScore(scoreResponse);
            }
            else
            {
                throw new Exception(response.ReasonPhrase);
            }

            return predictionScore;
        }
    }
}
