﻿using SenseHat.Portable.Helpers;
using System.Text;

namespace CustomIoTSolution.Common.Helpers
{
    public static class ConnectionStringHelper
    {
        public static string EndpointsProtocolProperty { get; private set; } = "DefaultEndpointsProtocol=https;";
        public static string AccountNameProperty { get; private set; } = "AccountName=";
        public static string AccountKeyProperty { get; private set; } = "AccountKey=";
        public static string BlobEndpointProperty { get; private set; } = "BlobEndpoint=";

        public static string GetBlobConnectionString(string accountName, string accountKey, string blobEndpoint)
        {
            Check.IsNull(accountName);
            Check.IsNull(accountKey);
            Check.IsNull(blobEndpoint);

            var stringBuilder = new StringBuilder(EndpointsProtocolProperty);

            // Set account name
            stringBuilder.Append(AccountNameProperty);
            stringBuilder.Append(accountName);
            stringBuilder.Append(";");

            // Set account key
            stringBuilder.Append(AccountKeyProperty);
            stringBuilder.Append(accountKey);
            stringBuilder.Append(";");

            // Set blob endpoint
            stringBuilder.Append(BlobEndpointProperty);
            stringBuilder.Append(blobEndpoint);
            stringBuilder.Append(";");

            return stringBuilder.ToString();
        }
    }
}