﻿using CustomIoTSolution.Common.Config;
using CustomIoTSolution.Common.Helpers;
using CustomIoTSolution.EventProcessor.Processors;
using Microsoft.ServiceBus.Messaging;
using System;

namespace CustomIoTSolution.EventProcessor
{
class Program
{
    static void Main(string[] args)
    {            
        try
        {
            // Prepare storage connection string
            var storageConnectionString = ConnectionStringHelper.GetBlobConnectionString(
                Configuration.AccountName,
                Configuration.AccountKey,
                Configuration.BlobEndPoint);

            // Instantiate EventProcessorHost
            var eventProcessorHost = new EventProcessorHost(
                Configuration.EventHubPath,
                Configuration.ConsumerGroupName,
                Configuration.EventHubConnectionString,
                storageConnectionString);

            // Register event processor
            // Note that, Wait is necessary here since an entry point method cannot be marked as async
            eventProcessorHost.RegisterEventProcessorAsync<TemperatureEventDataProcessor>().Wait();
        }
        catch (Exception ex)
        {
            Console.WriteLine(ex.Message);
        }
            
        Console.Read();
    }
}
}
