﻿#region Using

using CustomIoTSolution.NotificationClient.Models;
using SenseHat.UWP.Sensors;
using System;
using System.ComponentModel;
using System.Runtime.CompilerServices;

#endregion

namespace CustomIoTSolution.NotificationClient.ViewModels
{
    public class NotificationClientViewModel : INotifyPropertyChanged
    {
        #region Public properties

        public string RegistrationId
        {
            get { return registrationId; }
            set
            {
                registrationId = value;
                OnPropertyChanged();
            }
        }
        
        public SensorReadings SensorReadings
        {
            get { return sensorReadings; }
            set
            {
                sensorReadings = value;
                OnPropertyChanged();
            }
        }

        public TemperatureAlertInfo TemperatureAlertInfo
        {
            get { return temperatureAlertInfo; }
            set
            {
                temperatureAlertInfo = value;
                OnPropertyChanged();
            }
        }

        // Adjust this value to your needs
        public DateTimeOffset Offset { get; set; } = DateTime.Now.AddDays(-1);

        #endregion

        #region Events

        public event PropertyChangedEventHandler PropertyChanged = delegate { };

        #endregion

        #region Fields 

        private string registrationId;

        private SensorReadings sensorReadings = new SensorReadings();

        private TemperatureAlertInfo temperatureAlertInfo = new TemperatureAlertInfo();

        #endregion

        #region Methods

        private void OnPropertyChanged([CallerMemberName] string propertyName = "")
        {
            PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }

        #endregion
    }
}
